--Klein, MixNibbles step (encryption)

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY klein_mixnibbles IS
  PORT (
    h_state_in : IN STD_LOGIC_VECTOR(0 to 31);
    byte_out   : OUT STD_LOGIC_VECTOR(0 to 7)
    );
END klein_mixnibbles;

ARCHITECTURE rtl OF klein_mixnibbles IS

  COMPONENT klein_xtimes IS
    PORT (
      x_in  : IN STD_LOGIC_VECTOR(0 to 7);
      x_out : OUT STD_LOGIC_VECTOR(0 to 7)
      );
  END COMPONENT;
  
  signal xt_in  : STD_LOGIC_VECTOR(0 to 7);
  signal xt_out : STD_LOGIC_VECTOR(0 to 7);
  
BEGIN

  xt_in <= h_state_in(0 to 7) xor h_state_in(24 to 31);
  
  Inst_xtime : klein_xtimes port map(
    x_in  => xt_in,
    x_out => xt_out
  );
  
  byte_out <= xt_out xor
              h_state_in(8 to 15) xor
              h_state_in(16 to 23) xor
              h_state_in(0 to 7);
  
END rtl;

